Imports System
Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Windows.Forms
' the novapiLib package must be added as a    COM    refference
Imports novapiLib90


Module Module1
	'    <summary>
	'    The    main entry point for the application.
	'    </summary>
    Const PRINTER_NAME As String = "novaPDF SDK 9"

	Const PROFILE_NAME As String = "Test VBNet"
	Const PROFILE_IS_PUBLIC As Integer = 0
	Const NOVAPDF_INFO_SUBJECT As String = "Document Subject"

	Const NV_PROFILE_EXISTS As Long = -707133434

	Sub Main()
		Try
			' create the NovaPdfOptions object
            Dim pNova As NovaPdfOptions90
            pNova = New NovaPdfOptions90
			' initialize the NovaPdfOptions object
			' if you have an application license for novaPDF SDK, 
            ' pass the license key to the Initialize() function
            pNova.Initialize(PRINTER_NAME, "")
			' mark start changing options
			' get the active profile ...
            Dim activeProfile As String = ""
            Dim nActivePublic As Integer = 0
            Try
                pNova.GetActiveProfile(activeProfile)
            Catch ex As System.Runtime.InteropServices.COMException
                ' ignore profile exists error
                If (NovaErrors.NV_NO_ACTIVE_PROFILE = ex.ErrorCode) Then
                    System.Console.WriteLine("The printer does not have an active profile")
                Else
                    'more	serious	error, propagate it
                    Throw ex
                End If
            End Try

            Dim newProfileID As String = ""
			Try
				' and make    a copy of it
                pNova.AddProfile(PROFILE_NAME, PROFILE_IS_PUBLIC, newProfileID)
			Catch e As System.Runtime.InteropServices.COMException
				' ignore profile exists error
				If (NV_PROFILE_EXISTS = e.ErrorCode) Then
					System.Console.WriteLine("Profile already exists")
				Else
					' more    serious    error, propagate it
					Throw e
				End If
            End Try

            'load the new profile
            pNova.LoadProfile(newProfileID)
            'nova.NovaTools.AddProfileOptions(pNova);

            ' and set some	options
            ' uncomment the function calls for the options you wish to set

            ' DO NOT OPEN PDF 
            ' an Open action is added by default in the profile - delete or disable this open action
            ' pNova.DisableActionType(ActionType.NOVA_ACTION_OPEN)

            ' change the options in the nova.cs unit
            'NovaTools.AddProfileOptions(pNova)
            'NovaTools.AddSaveOptions(pNova)
            'NovaTools.AddMergeOptions(pNova)
            'NovaTools.AddDocumentInformation(pNova)
            'NovaTools.AddDocumentXMPMetadata(pNova)
            'NovaTools.AddViewerOptions(pNova)
            'NovaTools.AddLinksOptions(pNova)
            'NovaTools.AddAdvancedOptions(pNova)
            'NovaTools.AddGraphicsOptions(pNova)
            'NovaTools.AddSecurityOptions(pNova)
            'NovaTools.AddWatermarkImage(pNova)
            'NovaTools.AddWatermarkText(pNova)
            'NovaTools.AddPageContentOptions(pNova)
            'NovaTools.AddOverlayOptions(pNova)
            'NovaTools.AddSignatureOptions(pNova)
            'NovaTools.AddEmbedFontsOptions(pNova)
            'NovaTools.AddBookmarksDefinitions(pNova)
            'NovaTools.AddActionsOptions(pNova)

            'save the new added profile
            pNova.SaveProfile()
            ' set the copy    profile    as active profile ...
            pNova.SetActiveProfile(newProfileID)

            pNova.RegisterNovaEvent(NovaEvents.NOVAPDF_EVENT_ACTIONS)

			' mark finish changing options so they are saved for the printer
            'pNova.EndUpdateProfiles()
			' print a test    page, using    the    previously set active profile settings
			Dim pd As PrintDocument = New PrintDocument
			pd.PrinterSettings.PrinterName = PRINTER_NAME
			AddHandler pd.PrintPage, AddressOf PrintPageFunction
            pd.Print()

            Dim bTimeout As Integer
            pNova.WaitForNovaEvent(120000, bTimeout)

            pNova.SetActiveProfile(activeProfile)
            pNova.DeleteProfile(newProfileID)
        Catch e As System.Runtime.InteropServices.COMException
            MessageBox.Show(e.Message)
		Catch e As Exception
			MessageBox.Show(e.Message)
		End Try
	End Sub

	' and finally the function that actually prints the page
	Private Sub PrintPageFunction(ByVal sender As Object, ByVal ev As PrintPageEventArgs)
		Dim str As String = "novaPDF says Hello World from VB.Net"
		Dim font As Font = New Font("Arial", 16)
		Dim brush As Brush = New SolidBrush(Color.Black)
		ev.Graphics.DrawString(str, font, brush, 20.0!, 20.0!)
		ev.HasMorePages = False
	End Sub

End Module
